'Oom010 (1/23/1999 6:20:31 pm)'.!


StringHolderView subclass: #OomPluggableStringHolderView
	instanceVariableNames: 'aspectSelector changeSelector menuSelector '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Pluggable-Support'!
!OomPluggableStringHolderView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomPluggableStringHolderView methodsFor: 'model access' stamp: 'nishis 7/24/1998 21:52'!
model: aModel 
	self model: aModel controller: self controller.
	controller performer: model.
	self editString: self contents! !


!OomPluggableStringHolderView methodsFor: 'controller access'!
defaultControllerClass 
	^OomPluggableStringHolderController! !


!OomPluggableStringHolderView methodsFor: 'pluggable support' stamp: 'nishis 7/24/1998 22:00'!
contents
	(self controller performer respondsTo: aspectSelector) 
		ifFalse: [^self model perform: aspectSelector]
		ifTrue: [^self controller performer perform: aspectSelector]! !

!OomPluggableStringHolderView methodsFor: 'pluggable support' stamp: 'nishis 7/24/1998 22:00'!
contents: aString
	(self controller performer respondsTo: changeSelector) 
		ifFalse: [^self model perform: changeSelector with: aString]
		ifTrue: [^self controller performer perform: changeSelector with: aString]! !

!OomPluggableStringHolderView methodsFor: 'pluggable support'!
menu
	^self model perform: menuSelector! !


!OomPluggableStringHolderView methodsFor: 'displaying' stamp: 'nishis 11/13/1998 18:42'!
displayView 
	| visibleAreas backgroundColor |
	visibleAreas := self visibleAreas.
	backgroundColor := self backgroundColor.
	visibleAreas 
		do: 
			[:rectangle | 
			backgroundColor notNil 
				ifTrue: [Display fill: rectangle fillColor: backgroundColor].
			self displayContents
					displayOn: Display
					at: self insetDisplayBox origin 
					clippingBox: rectangle]! !


!OomPluggableStringHolderView methodsFor: 'updating'!
updateDisplayContents
	self editString: self contents.
	self displayView! !


!OomPluggableStringHolderView methodsFor: 'private'!
on: aModel aspect: aspectSymbol change: changeSymbol menu: menuSymbol
	aspectSelector := aspectSymbol.
	changeSelector := changeSymbol.
	menuSelector := menuSymbol.
	self model: aModel! !

!OomPluggableStringHolderView methodsFor: 'private' stamp: 'nishis 11/13/1998 18:38'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomPluggableStringHolderView class
	instanceVariableNames: ''!

!OomPluggableStringHolderView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomPluggableStringHolderView class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:40'!
readme
	"Originally written by Mr. AOKI Atsushi, modified by nishis."! !

!OomPluggableStringHolderView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomPluggableStringHolderView class methodsFor: 'copyright'!
version
	^'010'! !


!OomPluggableStringHolderView class methodsFor: 'instance creation' stamp: 'nishis 5/2/98 01:46'!
new
	^super new initialize! !

!OomPluggableStringHolderView class methodsFor: 'instance creation'!
on: aModel aspect: aspectSymbol change: changeSymbol menu: menuSymbol
	| aView |
	aView := self new.
	aView
		on: aModel
		aspect: aspectSymbol
		change: changeSymbol
		menu: menuSymbol.
	^aView! !
