'Oom010 (1/23/1999 6:20:33 pm)'.!


Model subclass: #OomButtonModel
	instanceVariableNames: 'buttonValue displayObject buttonAction repeatAction isEnabled '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Button'!
!OomButtonModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomButtonModel methodsFor: 'accessing'!
action
	buttonAction isNil ifTrue: [self action: []].
	^buttonAction! !

!OomButtonModel methodsFor: 'accessing'!
action: aBlock 
	buttonAction := aBlock! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 23:51'!
disable
	^self isEnabled: false! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 23:51'!
enable
	^self isEnabled: true! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 14:20'!
isEnabled
	isEnabled isNil ifTrue: [self isEnabled: true].
	^isEnabled! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 23:50'!
isEnabled: aBoolean 
	| bool |
	(aBoolean respondsTo: #value)
		ifTrue: [bool := aBoolean value = true]
		ifFalse: [bool := aBoolean = true].
	bool = isEnabled
		ifFalse: 
			[isEnabled := bool.
			self changed: #value]! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 13:36'!
repeatAction
	^repeatAction = true! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 13:36'!
repeatAction: aBoolean 
	repeatAction := aBoolean = true! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/25/1998 13:30'!
value
	buttonValue isNil ifTrue: [self value: false].
	^buttonValue! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 8/15/1998 19:54'!
value: aBoolean 
	| bool |
	(aBoolean respondsTo: #value)
		ifTrue: [bool := aBoolean value = true]
		ifFalse: [bool := aBoolean = true].
	bool = buttonValue
		ifFalse: 
			[buttonValue := bool.
			self changed: #value]! !

!OomButtonModel methodsFor: 'accessing'!
visual
	displayObject isNil ifTrue: [self visual: String new].
	^displayObject! !

!OomButtonModel methodsFor: 'accessing' stamp: 'nishis 7/26/1998 02:20'!
visual: anObject 
	| visual |
	(anObject respondsTo: #value)
		ifTrue: [visual := anObject value]
		ifFalse: [visual := anObject].
	visual = displayObject
		ifFalse: 
			[((visual respondsTo: #boundingBox) and: [visual respondsTo: #displayOn:])
				ifTrue: [displayObject := visual]
				ifFalse:
					[visual isNil
						ifTrue: [displayObject := nil]
						ifFalse:
							[displayObject := Paragraph 
								withText: visual printString asText
								style: TextStyle default copy.
							(visual isKindOf: String)
								ifTrue: [displayObject := visual asText allBold asParagraph].
							(visual isKindOf: Text)
								ifTrue: [displayObject := visual allBold asParagraph].
							(visual isKindOf: Paragraph) 
								ifTrue: [displayObject := visual]]].
			self changed: #visual]! !


!OomButtonModel methodsFor: 'constructing' stamp: 'nishis 11/14/1998 11:49'!
compute: aBlock 
	OomBlockListener block: aBlock arguments: (Array with: self)! !


!OomButtonModel methodsFor: 'interface opening'!
createButtonView
	| view |
	view := OomButtonView new.
	view model: self.
	^view! !

!OomButtonModel methodsFor: 'interface opening' stamp: 'nishis 10/21/1998 00:52'!
open
	| topView leftView |
	topView := OomAlteredScheduledView
		model: self
		label: 'Button'
		minimumSize: (100 @ 100) + 0
		maximumSize: (100 @ 100) + 0.
	leftView := self createButtonView.
	topView addSubView: leftView.
	topView borderWidth: 2.
	topView controller openAt: 100 @ 100! !


!OomButtonModel methodsFor: 'printing'!
printOn: aStream 
	super printOn: aStream.
	aStream nextPutAll: ' on: '.
	self value printOn: aStream! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomButtonModel class
	instanceVariableNames: ''!

!OomButtonModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomButtonModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomButtonModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomButtonModel class methodsFor: 'instance creation'!
value: aBoolean visual: anObject 
	| buttonModel |
	buttonModel := self new.
	buttonModel value: aBoolean.
	buttonModel visual: anObject.
	^buttonModel! !

!OomButtonModel class methodsFor: 'instance creation' stamp: 'nishis 7/25/1998 13:31'!
value: aBoolean visual: anObject action: aBlock 
	| buttonModel |
	buttonModel := self new.
	buttonModel value: aBoolean.
	buttonModel visual: anObject.
	buttonModel action: aBlock.
	^buttonModel! !


!OomButtonModel class methodsFor: 'examples' stamp: 'nishis 7/28/1998 23:47'!
example1
	"OomButtonModel example1."

	| buttonModel |
	buttonModel := OomButtonModel
				value: false
				visual: 'Aoki' asText allBold
				action: [:model | model value: model value not].
	buttonModel compute: [:buttonValue | Transcript show: ' ', buttonValue printString].
	buttonModel open.
	^buttonModel! !

!OomButtonModel class methodsFor: 'examples' stamp: 'nishis 7/25/1998 15:32'!
example2
	"OomButtonModel example2."

	| buttonModel |
	buttonModel := OomButtonModel
				value: true
				visual: Cursor execute 
				action: [:model | model value: model value not].
	buttonModel open.
	^buttonModel! !

!OomButtonModel class methodsFor: 'examples' stamp: 'nishis 7/25/1998 14:40'!
example3
	"OomButtonModel example3."

	| buttonModel |
	buttonModel := OomButtonModel
				value: false
				visual: Form fromUser
				action: [:model | model value: model value not].
	buttonModel repeatAction: true.
	buttonModel open.
	^buttonModel! !
