'Oom010 (1/23/1999 6:20:34 pm)'.!


OomMetricCK subclass: #OomMetricNOC
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricNOC commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNOC methodsFor: 'computing'!
compute
	"(OomMetricNOC classes: Magnitude withAllSubclasses) compute."

	^self computeNOCs! !

!OomMetricNOC methodsFor: 'computing'!
computeNOC: aClass 
	"OomMetricNOC new computeNOC: Integer."

	^aClass subclasses size! !

!OomMetricNOC methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:22'!
computeNOCs
	"(OomMetricNOC classes: Magnitude withAllSubclasses) computeNOCs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeNOC: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNOC class
	instanceVariableNames: ''!

!OomMetricNOC class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNOC class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNOC class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNOC class methodsFor: 'description'!
description
	^'number of children'! !

!OomMetricNOC class methodsFor: 'description'!
nickname
	^'NOC'! !


!OomMetricNOC class methodsFor: 'examples'!
example1
	"OomMetricNOC example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOC classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNOC class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:34'!
example2
	"OomMetricNOC example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNOC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:22'!
example3
	"OomMetricNOC example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNOC class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:22'!
example4
	"OomMetricNOC example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOC classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 10
				rank: 10.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
