'Oom010 (1/23/1999 6:20:34 pm)'.!


StringHolder subclass: #OomPluggableStringHolderModel
	instanceVariableNames: 'selectionMenu '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Pluggable-Support'!
!OomPluggableStringHolderModel commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi!


!OomPluggableStringHolderModel methodsFor: 'initialize-release'!
defaultBackgroundColor
	^#white! !


!OomPluggableStringHolderModel methodsFor: 'accessing' stamp: 'nishis 4/26/98 21:06'!
textCollector
	^Transcript! !


!OomPluggableStringHolderModel methodsFor: 'pluggable messages'!
menu
	| collection |
	selectionMenu isNil
		ifTrue:
			[collection := OrderedCollection new.
			collection add: 'find...' -> #find.
			collection add: 'find again' -> #findAgain.
			collection add: 'set search string' -> #setSearchString.
			collection add: nil.
			collection add: 'do again' -> #again.
			collection add: 'undo' -> #undo.
			collection add: nil.
			collection add: 'copy' -> #copySelection.
			collection add: 'cut' -> #cut.
			collection add: 'paste' -> #paste.
			collection add: nil.
			collection add: 'do it' -> #doIt.
			collection add: 'print it' -> #printIt.
			collection add: 'inspect it' -> #inspectIt.
			collection add: nil.
			collection add: 'accept' -> #accept.
			collection add: 'cancel' -> #cancel.
			collection add: nil.
			collection add: 'doSomething' -> #doSomething.
			collection add: 'doSomething:' -> #doSomething:.
			collection add: 'doSomething:with:' -> #doSomething:with:.
			collection add: 'doSomething:with:with:' -> #doSomething:with:with:.
			selectionMenu := self makeSelectionMenu: collection].
	^selectionMenu! !


!OomPluggableStringHolderModel methodsFor: 'menu messages'!
doSomething
	self textCollector cr; show: thisContext printString! !

!OomPluggableStringHolderModel methodsFor: 'menu messages'!
doSomething: selectedString
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString! !

!OomPluggableStringHolderModel methodsFor: 'menu messages'!
doSomething: selectedString with: wholeString
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString.
	self textCollector cr; tab; show: '2nd argument is ' , wholeString printString! !

!OomPluggableStringHolderModel methodsFor: 'menu messages' stamp: 'nishis 11/9/1998 10:37'!
doSomething: selectedString with: wholeString with: aController
	self textCollector cr; show: thisContext printString.
	self textCollector cr; tab; show: '1st argument is ' , selectedString printString.
	self textCollector cr; tab; show: '2nd argument is ' , wholeString printString.
	self textCollector cr; tab; show: '3rd argument is ' , aController printString! !


!OomPluggableStringHolderModel methodsFor: 'private'!
makeSelectionMenu: aCollection
	| labels lines selectors |
	aCollection isEmpty ifTrue: [^nil].
	labels := OrderedCollection new.
	lines := OrderedCollection new.
	selectors := OrderedCollection new.
	aCollection do: [:association |
		association isNil
			ifTrue: [lines add: labels size]
			ifFalse:
				[labels add: association key.
				selectors add: association value]].
	^SelectionMenu 
		labelList: labels asArray
		lines: lines asArray
		selections: selectors asArray! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomPluggableStringHolderModel class
	instanceVariableNames: ''!

!OomPluggableStringHolderModel class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1998 NISHIHARA Satoshi'! !

!OomPluggableStringHolderModel class methodsFor: 'copyright' stamp: 'nishis 11/14/1998 13:41'!
readme
	"Originally written by Mr. AOKI Atsushi, modified by nishis."! !

!OomPluggableStringHolderModel class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomPluggableStringHolderModel class methodsFor: 'copyright'!
version
	^'010'! !


!OomPluggableStringHolderModel class methodsFor: 'examples'!
example1
	"OomPluggableStringHolderModel example1."

	| aPluggableStringHolderModel aPluggableStringHolderView aStandardSystemView |
	aPluggableStringHolderModel := OomPluggableStringHolderModel new.
	aPluggableStringHolderView := OomPluggableStringHolderView
			on: aPluggableStringHolderModel
			aspect: #contents
			change: #contents:
			menu: #menu.
	aPluggableStringHolderView borderWidth: 1.
	aStandardSystemView := StandardSystemView new.
	aStandardSystemView borderWidth: 1.
	aStandardSystemView model: aPluggableStringHolderModel.
	aStandardSystemView addSubView: aPluggableStringHolderView.
	aStandardSystemView label: 'Pluggable String Holder'.
	aStandardSystemView minimumSize: 100 @ 50.
	aStandardSystemView controller open! !
