'Oom010 (1/23/1999 6:20:35 pm)'.!


Object subclass: #OomSourceCodeSaver
	instanceVariableNames: 'name categories filter '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-System-Support'!
!OomSourceCodeSaver commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomSourceCodeSaver methodsFor: 'accessing'!
categories
	^categories! !

!OomSourceCodeSaver methodsFor: 'accessing' stamp: 'nishis 11/13/1998 11:38'!
directory
	| saveDirectory localName directories defaultDirectory |
	localName := self name.
	defaultDirectory := FileDirectory default copy.
	directories := localName findTokens: FileDirectory pathNameDelimiter asString.
	directories 
		do:
			[:subDirectory | 
			(defaultDirectory includesKey: subDirectory)
				ifFalse: [defaultDirectory createDirectory: subDirectory].
			defaultDirectory := FileDirectory on: 
					(defaultDirectory pathName, 
					(String with: FileDirectory pathNameDelimiter), 
					subDirectory)].
	saveDirectory := FileDirectory on: self class defaultDirectoryName , self name.
	^saveDirectory! !

!OomSourceCodeSaver methodsFor: 'accessing'!
filter
	^filter! !

!OomSourceCodeSaver methodsFor: 'accessing'!
name
	^name! !

!OomSourceCodeSaver methodsFor: 'accessing' stamp: 'nishis 3/29/98 10:31'!
name: nameString categories: stringArray filter: filterBlock 
	name := nameString asString.
	categories := (stringArray collect: [:each | each asString]) asArray.
	filter := filterBlock.
	^self! !


!OomSourceCodeSaver methodsFor: 'classes'!
allClassNames
	^self allClasses collect: [:each | each name]! !

!OomSourceCodeSaver methodsFor: 'classes' stamp: 'nishis 3/29/98 05:11'!
allClasses
	| rootClasses allClasses blockClosure |
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	blockClosure := [:each | ((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: [allClasses add: each]].
	rootClasses
		do: 
			[:root | 
			blockClosure value: root.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each]]].
	^allClasses asArray! !

!OomSourceCodeSaver methodsFor: 'classes'!
allNumberOfClasses
	^self allClasses size! !

!OomSourceCodeSaver methodsFor: 'classes'!
classNames
	^self classes collect: [:each | each name]! !

!OomSourceCodeSaver methodsFor: 'classes' stamp: 'nishis 6/1/98 03:54'!
classes
	| blockClosure rootClasses allClasses patterns |
	self categories isNil ifTrue: [^Array new].
	blockClosure := 
			[:each :classes | 
			((each isKindOf: Behavior) and: [each isMeta not])
				ifTrue: 
					[patterns := self categories select: [:pattern | self class stringMatch: each category asString and: pattern].
					(patterns isEmpty not and: [self filter value: each])
						ifTrue: [classes add: each]]].
	rootClasses := self privateValues select: [:each | ((each isKindOf: Behavior) and: [each isMeta not])
					and: [each superclass isNil]].
	allClasses := OrderedCollection new.
	rootClasses
		do: 
			[:root | 
			blockClosure value: root value: allClasses.
			root allSubclasses do: [:each | (rootClasses includes: each) not ifTrue: [blockClosure value: each value: allClasses]]].
	^(ChangeSet superclassOrder: allClasses) asArray
	"^allClasses asArray"! !

!OomSourceCodeSaver methodsFor: 'classes'!
numberOfClasses
	^self classes size! !


!OomSourceCodeSaver methodsFor: 'messages'!
messages
	| instanceMessages classMessages |
	instanceMessages := Set new.
	classMessages := Set new.
	self classes
		do: 
			[:each | 
			instanceMessages addAll: each selectors.
			classMessages addAll: each class selectors].
	instanceMessages := instanceMessages asSortedCollection.
	classMessages := classMessages asSortedCollection.
	^Array with: instanceMessages with: classMessages! !

!OomSourceCodeSaver methodsFor: 'messages'!
numberOfMessages
	^self messages collect: [:each | each size]! !


!OomSourceCodeSaver methodsFor: 'saving' stamp: 'nishis 3/29/98 11:46'!
save
	Cursor write
			showWhile:[self saveWithCursorWrite]! !

!OomSourceCodeSaver methodsFor: 'saving'!
savePrefix
	^'Src' copy! !

!OomSourceCodeSaver methodsFor: 'saving' stamp: 'nishis 11/13/1998 12:44'!
saveWithCursorWrite
	| savingClasses separatorString extensionString saveDirectory baseString fileNames fileNo fileName writeStream stream filename localName |
	savingClasses := self classes.
	savingClasses isEmpty ifTrue: [^nil].
	savingClasses size > 1
		ifTrue: [Transcript cr; cr; show: self name , ': saving ' , savingClasses size printString , ' classes ...']
		ifFalse: [Transcript cr; cr; show: self name , ': saving ' , savingClasses size printString , ' class ...'].
	separatorString := String with: FileDirectory pathNameDelimiter.
	extensionString := '.st'.
	saveDirectory := self directory.
	(saveDirectory containingDirectory includesKey: saveDirectory pathParts last)
		ifTrue: [saveDirectory fileNames
				do: 
					[:each | 
					localName := self name , separatorString , each.
					filename := self class defaultDirectoryName , localName.
					(FileDirectory on: self class defaultDirectoryName, self name) 						deleteFileNamed: each 
						ifAbsent: []]]
		ifFalse: 
			[saveDirectory containingDirectory 
					createDirectory: saveDirectory pathParts last].
	baseString := String new.
	8 - self savePrefix size timesRepeat: [baseString := baseString , '0'].
	fileNames := OrderedCollection new.
	fileNo := 1.
	savingClasses
		do: 
			[:each | 
			stream := WriteStream on: (String new: 12).
			stream nextPutAll: self savePrefix.
			baseString size - fileNo printString size timesRepeat: [stream nextPutAll: '0'].
			stream nextPutAll: fileNo printString.
			stream nextPutAll: extensionString.
			fileNames add: stream contents.
			filename := self class defaultDirectoryName , self name.
			filename := filename , separatorString , stream contents.
			filename := FileStream fileNamed: filename.
			self privateSaveClass: each into: filename.
			filename close.
			Transcript show: ' -> ' , stream contents.
			fileNo := fileNo + 1].
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , self savePrefix , baseString , extensionString.
	Transcript cr; show: self name , ' -> ' , self savePrefix , baseString , extensionString.
	writeStream := (FileStream fileNamed: fileName).
	[self privateSaveInstallation: savingClasses
			into: writeStream
			files: fileNames]
		ifError: [:msg :rec | writeStream close].
	writeStream close.
	fileName := self class defaultDirectoryName , self name.
	fileName := fileName , separatorString , 'Install' , extensionString.
	Transcript cr; show: 'All ' , self name , ' -> ' , 'Install' , extensionString.
	fileNames := Array with: self savePrefix , baseString , extensionString.
	writeStream := FileStream fileNamed: fileName.
	[self privateSaveInstall: fileNames into: writeStream] 
		ifError: [:msg :rec | writeStream close].
	writeStream close.
	Transcript cr; show: '... done at ' , Date today printString , ' ' , Time now printString! !


!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 06:44'!
privateSaveCategories: allClasses into: aStream 
	(allClasses collect: [:each | each category]) asSet asSortedCollection
		do: 
			[:each | 
			aStream nextPutAll: '(SystemOrganization categories includes: '.
			aStream nextPutAll: each asString printString.
			aStream nextPutAll: ' asSymbol'.
			aStream nextPutAll: ')'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: 'ifFalse: ['.
			aStream nextPutAll: 'SystemOrganization addCategory: '.
			aStream nextPutAll: each asString printString.
			aStream nextPutAll: ' asSymbol'.
			aStream nextPutAll: '].'.
			aStream nextChunkPut: String new.
			aStream cr].
	aStream cr.
	aStream cr.
	^aStream! !

!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 10:33'!
privateSaveClass: aClass into: aFile 
	self privateSaveHeaderInto: aFile.
	aClass fileOutOn: aFile! !

!OomSourceCodeSaver methodsFor: 'private'!
privateSaveDefinitions: allClasses into: aStream 
	allClasses
		do: 
			[:each | 
			aStream nextPutAll: each definition.
			aStream nextPutAll: '.'.
			aStream nextChunkPut: String new.
			aStream cr.
			aStream cr].
	aStream cr.
	^aStream! !

!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 10/19/1998 11:46'!
privateSaveFileInProgram: fileNames into: aStream 
	| limit count index collection segment |
	limit := 100.
	count := fileNames size // limit.
	fileNames size \\ limit = 0 ifFalse: [count := count + 1].
	index := 1.
	collection := OrderedCollection new: count.
	count
		timesRepeat: 
			[segment := OrderedCollection new: limit.
			1 to: limit
				do: 
					[:n | 
					index <= fileNames size ifTrue: [segment add: (fileNames at: index)].
					index := index + 1].
			collection add: segment].
	collection
		do: 
			[:names | 
			aStream nextPutAll: '| separatorString directoryString |'.
			aStream cr.
			aStream nextPutAll: '#('.
			aStream cr.
			names
				do: 
					[:each | 
					each printOn: aStream.
					aStream cr].
			aStream nextPutAll: ')'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: ' do:'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: '[:aString |'.
			aStream cr.
"
			aStream tab; tab.
			aStream nextPutAll: '| separatorString directoryString |'.
			aStream cr.
"
			aStream tab; tab.
			aStream nextPutAll: 'separatorString := String with: FileDirectory pathNameDelimiter'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: 'directoryString := FileDirectory default pathName'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: 'directoryString last = FileDirectory pathNameDelimiter'.
			aStream cr.
			aStream tab; tab; tab.
			aStream nextPutAll: 'ifTrue: [directoryString := directoryString , '.
			aStream nextPutAll: self name printString.
			aStream nextPutAll: ' , separatorString]'.
			aStream cr.
			aStream tab; tab; tab.
			aStream nextPutAll: 'ifFalse: [directoryString := directoryString , separatorString , '.
			aStream nextPutAll: self name printString.
			aStream nextPutAll: ' , separatorString]'.
			aStream nextPutAll: '.'.
			aStream cr.
			aStream tab; tab.
			aStream nextPutAll: '(FileStream oldFileNamed: directoryString , aString)'.
			aStream nextPutAll: ' fileIn].'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: 'Browser allInstancesDo: [:each | each updateSystemCategories].'.
			aStream cr.
			aStream tab.
			aStream nextPutAll: 'ScheduledControllers screenController restoreDisplay'.
			aStream nextChunkPut: String new.
			aStream cr.
			aStream cr].
	^aStream! !

!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 05:43'!
privateSaveHeaderInto: aStream 
	| header |
	header := WriteStream on: (String new: 128).
	header nextPutAll: self name.
	header space.
	header nextPutAll: '('.
	header nextPutAll: Date today mmddyyyy.
	header space.
	header nextPutAll: Time now asString.
	header nextPutAll: ')'.
	aStream nextPutAll: header contents printString.
	aStream nextPutAll: '.'.
	aStream nextChunkPut: String new.
	aStream cr.
	aStream cr.
	aStream cr.
	^aStream! !

!OomSourceCodeSaver methodsFor: 'private'!
privateSaveInstall: fileNames into: aStream 
	self privateSaveHeaderInto: aStream.
	self privateSaveFileInProgram: fileNames into: aStream! !

!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 11/13/1998 11:42'!
privateSaveInstallation: allClasses into: aStream files: fileNames 
	| collection key value |
	self privateSaveHeaderInto: aStream.
	collection := SortedCollection new: allClasses size.
	allClasses with: fileNames
		do: 
			[:aClass :fileName | 
			key := aClass name.
			value := fileName.
			collection add: key -> value].
	collection
		do: 
			[:association | 
			aStream nextPutAll: association storeString.
			aStream nextPutAll: '.'.
			aStream nextChunkPut: String new.
			aStream cr].
	aStream cr.
	aStream cr.
	self privateSaveCategories: allClasses into: aStream.
	self privateSaveDefinitions: allClasses into: aStream.
	self privateSaveFileInProgram: fileNames into: aStream.
	aStream cr.
	aStream nextChunkPut: 'OomSystem install.'.
	aStream cr.
	^aStream! !

!OomSourceCodeSaver methodsFor: 'private' stamp: 'nishis 3/29/98 05:11'!
privateValues
	^ self class privateValues
! !


!OomSourceCodeSaver methodsFor: 'methods' stamp: 'nishis 7/19/1998 11:05'!
methods
	| instanceMethods classMethods |
	instanceMethods := Bag new.
	classMethods := Bag new.
	self classes
		do: 
			[:each | 
			instanceMethods addAll: each selectors.
			classMethods addAll: each class selectors].
	instanceMethods := instanceMethods asSortedCollection.
	classMethods := classMethods asSortedCollection.
	^Array with: instanceMethods with: classMethods! !

!OomSourceCodeSaver methodsFor: 'methods' stamp: 'nishis 7/19/1998 11:05'!
numberOfMethods
	^self methods collect: [:each | each size]! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomSourceCodeSaver class
	instanceVariableNames: ''!

!OomSourceCodeSaver class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomSourceCodeSaver class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomSourceCodeSaver class methodsFor: 'copyright'!
version
	^'010'! !


!OomSourceCodeSaver class methodsFor: 'instance creation'!
name: nameString categories: symbolArray 
	^super new
		name: nameString
		categories: symbolArray
		filter: [:aClass | true]! !

!OomSourceCodeSaver class methodsFor: 'instance creation'!
name: nameString categories: stringArray filter: filterBlock 
	^super new
		name: nameString
		categories: stringArray
		filter: filterBlock! !


!OomSourceCodeSaver class methodsFor: 'utilities' stamp: 'nishis 3/29/98 11:17'!
defaultDirectoryName
	"OomSourceCodeSaver defaultDirectoryName."

	| directoryName |
	directoryName := FileDirectory default pathName.
	directoryName last = FileDirectory pathNameDelimiter 
		ifFalse: 
			[directoryName := directoryName, (String with: FileDirectory pathNameDelimiter)].
	^directoryName! !

!OomSourceCodeSaver class methodsFor: 'utilities'!
stringMatch: string and: pattern 
	"OomSourceCodeSaver stringMatch: ' Aoki' and: '*[A-B]?ki'."

	| s1 s2 |
	s1 := WriteStream on: (String new: 20).
	s1 nextPutAll: string.
	s1 nextPut: (Character value: 0).
	s2 := WriteStream on: (String new: 20).
	s2 nextPutAll: pattern.
	s2 nextPut: (Character value: 0).
	^self
		stringMatch: s1 contents
		sIndex: 1
		and: s2 contents
		pIndex: 1! !

!OomSourceCodeSaver class methodsFor: 'utilities'!
stringMatch: string sIndex: sindex and: pattern pIndex: pindex 
	| scc c si pi ok lc |
	si := sindex.
	pi := pindex.
	scc := string at: si.
	si := si + 1.
	c := pattern at: pi.
	pi := pi + 1.
	c = $[
		ifTrue: 
			[ok := false.
			lc := 255.
			[c := pattern at: pi.
			pi := pi + 1.
			c ~= (Character value: 0)]
				whileTrue: [c = $]
						ifTrue: [ok
								ifTrue: [^self
										stringMatch: string
										sIndex: si
										and: pattern
										pIndex: pi]
								ifFalse: [^false]]
						ifFalse: [c = $-
								ifTrue: 
									[(lc <= scc and: [scc <= (pattern at: pi)])
										ifTrue: [ok := true].
									pi := pi + 1]
								ifFalse: 
									[lc := c.
									scc = c ifTrue: [ok := true]]]]].
	c = $? ifTrue: [scc ~= (Character value: 0)
			ifTrue: [^self
					stringMatch: string
					sIndex: si
					and: pattern
					pIndex: pi]
			ifFalse: [^false]].
	c = $*
		ifTrue: 
			[(pattern at: pi)
				= (Character value: 0) ifTrue: [^true].
			si := si - 1.
			[(string at: si)
				~= (Character value: 0)]
				whileTrue: 
					[(self
						stringMatch: string
						sIndex: si
						and: pattern
						pIndex: pi)
						ifTrue: [^true].
					si := si + 1].
			^false].
	c = (Character value: 0) ifTrue: [^scc = (Character value: 0)].
	c ~= scc ifTrue: [^false].
	scc ~= (Character value: 0)
		ifTrue: [^self
				stringMatch: string
				sIndex: si
				and: pattern
				pIndex: pi]
		ifFalse: [^false]! !


!OomSourceCodeSaver class methodsFor: 'examples' stamp: 'nishis 11/13/1998 11:49'!
example1
	"OomSourceCodeSaver example1."

	| sourceCodeSaver |
	sourceCodeSaver := OomSourceCodeSaver
				name: 'Name001'
				categories: #('Oom-*')
				filter: [:aClass | aClass name = OomSourceCodeSaver name].
	sourceCodeSaver save.
	^sourceCodeSaver! !

!OomSourceCodeSaver class methodsFor: 'examples' stamp: 'nishis 11/13/1998 11:51'!
example2
	"OomSourceCodeSaver example2."

	| sourceCodeSaver |
	sourceCodeSaver := OomSourceCodeSaver
				name: 'Name001'
				categories: #('Oom-*').
	Transcript cr; show: 'classes: '.
	Transcript space; show: sourceCodeSaver numberOfClasses printString.
	Transcript cr; show: 'instance messages & class messages: '.
	Transcript space; show: sourceCodeSaver numberOfMessages printString.
	^sourceCodeSaver! !


!OomSourceCodeSaver class methodsFor: 'private' stamp: 'nishis 3/29/98 05:11'!
privateValues
	| anOrderedCollection |
	anOrderedCollection := OrderedCollection new: Smalltalk size.
	Smalltalk do: [:value | anOrderedCollection add: value].
	^anOrderedCollection! !
