'Oom010 (1/23/1999 6:20:36 pm)'.!


OomMetricAoki subclass: #OomMetricMP
	instanceVariableNames: 'scope references '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Aoki'!
!OomMetricMP commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricMP methodsFor: 'accessing'!
classes: classCollection 
	self classes == self scope
		ifTrue: 
			[scope := nil.
			references := nil].
	super classes: classCollection! !

!OomMetricMP methodsFor: 'accessing'!
references
	references isNil ifTrue: [references := self computeReferences].
	^references! !

!OomMetricMP methodsFor: 'accessing'!
scope
	scope isNil ifTrue: [scope := self classes].
	^scope! !

!OomMetricMP methodsFor: 'accessing'!
scope: classCollection 
	| collection |
	collection := OrderedCollection new: classCollection size.
	classCollection do: [:aClass | (aClass isMeta not and: [(collection includes: aClass) not])
			ifTrue: [collection add: aClass]].
	scope := collection.
	references := nil! !


!OomMetricMP methodsFor: 'computing'!
compute
	"(OomMetricMP classes: Magnitude withAllSubclasses) compute."

	^self computeMPs! !

!OomMetricMP methodsFor: 'computing' stamp: 'nishis 5/17/98 22:09'!
computeMP: aSelector 
	| aMP referenceCount |
	aMP := 0.
	(self values: self references)
		do: 
			[:dictionary | 
			referenceCount := dictionary at: aSelector ifAbsent: [nil].
			referenceCount notNil ifTrue: [aMP := aMP + referenceCount]].
	^aMP! !

!OomMetricMP methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:05'!
computeMPs
	"(OomMetricMP classes: Magnitude withAllSubclasses) computeMPs."

	| targets size dictionary count |
	targets := Set new.
	self classes
		do: 
			[:each | 
			targets addAll: each selectors.
			targets addAll: each class selectors].
	size := targets size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each -> (self computeMP: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricMP methodsFor: 'computing'!
computeReferences
	"(OomMetricMP classes: Magnitude withAllSubclasses) computeReferences."

	| size targets dictionary count |
	size := (targets := self scope) size.
	dictionary := IdentityDictionary new: size.
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each -> (self computeReferences: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

!OomMetricMP methodsFor: 'computing'!
computeReferences: aClass 
	"OomMetricMP new computeReferences: OomMetricMP."

	| dictionary refs |
	dictionary := IdentityDictionary new.
	aClass selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass selector: selector.
			refs do: [:each | (dictionary includesKey: each)
					ifTrue: [dictionary add: each -> (1 + (dictionary at: each))]
					ifFalse: [dictionary add: each -> 1]]].
	aClass class selectors
		do: 
			[:selector | 
			refs := self computeReferences: aClass class selector: selector.
			refs do: [:each | (dictionary includesKey: each)
					ifTrue: [dictionary add: each -> (1 + (dictionary at: each))]
					ifFalse: [dictionary add: each -> 1]]].
	^dictionary! !

!OomMetricMP methodsFor: 'computing' stamp: 'nishis 5/17/98 22:54'!
computeReferences: aClass selector: aSelector 
	"[OomMetricMP new 
		computeReferences: OomMetricMP 
		selector: #computeReferences:selector:.] method symbolic"

	| bag stream line tokens index |
	bag := Bag new.
	self 
		withAllBlockMethodsDo:  
			[:method | 
			stream := ReadStream on: method symbolic.
			[stream atEnd]
				whileFalse: 
					[line := self getLine: stream.
					tokens := self separate: line dividers: self separators.
					"index := tokens findFirst: [:each | each = 'send']."
					index := tokens findFirst: [:each | each = 'send:'].
					(index ~= 0 and: [tokens size = (index + 1)])
						ifTrue: [bag add: (tokens at: index + 1) asSymbol]]]
		with: (aClass compiledMethodAt: aSelector).
	^bag! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricMP class
	instanceVariableNames: ''!

!OomMetricMP class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricMP class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricMP class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricMP class methodsFor: 'description'!
description
	^'message popularity'! !

!OomMetricMP class methodsFor: 'description'!
item
	^'message name'! !

!OomMetricMP class methodsFor: 'description'!
nickname
	^'MP'! !


!OomMetricMP class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:25'!
example1
	"OomMetricMP example1."

	| classes calculator animator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricMP classes: classes.
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [result := calculator compute].
	calculator report: result.
	^result! !

!OomMetricMP class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example2
	"OomMetricMP example2."

	| classes calculator progress animator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricMP classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	calculator report2: result.
	^result! !

!OomMetricMP class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:25'!
example3
	"OomMetricMP example3."

	| classes calculator progress animator result matrix table collection |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricMP classes: classes.
	collection := Collection withAllSubclasses asOrderedCollection.
	collection addAll: Magnitude withAllSubclasses.
	calculator scope: collection.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	animator := OomCursorAnimator clockCursors.
	animator tick: 1000.
	animator showWhile: [progress do: [result := calculator compute]].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !
