'Oom010 (1/23/1999 6:20:37 pm)'.!


Object subclass: #OomCursorAnimator
	instanceVariableNames: 'cursors tick '
	classVariableNames: 'ClockCursors HandCursors '
	poolDictionaries: ''
	category: 'Oom-Interface-Progress'!
!OomCursorAnimator commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomCursorAnimator methodsFor: 'accessing'!
cursors
	cursors isNil ifTrue: [cursors := OrderedCollection new].
	^cursors! !

!OomCursorAnimator methodsFor: 'accessing'!
cursors: cursorCollection 
	cursors := cursorCollection asOrderedCollection! !

!OomCursorAnimator methodsFor: 'accessing' stamp: 'nishis 5/17/98 16:33'!
tick
	tick isNil ifTrue: [tick := 250].
	^tick! !

!OomCursorAnimator methodsFor: 'accessing'!
tick: milliseconds 
	tick := 10 max: (milliseconds min: 10000)! !


!OomCursorAnimator methodsFor: 'animation' stamp: 'nishis 5/17/98 16:49'!
showWhile: aBlock 
	(self cursors size = 1)
		ifTrue: [^self showWhileWithNoAmination: aBlock].
	^self showWhile: aBlock interim: nil! !

!OomCursorAnimator methodsFor: 'animation' stamp: 'nishis 12/20/1998 22:21'!
showWhile: aBlock interim: interimBlock 
	| cursor process result index |
	cursor := Cursor currentCursor.
	process := 
			[[index := 1.
				[true]
					whileTrue: 
						[interimBlock notNil ifTrue: [interimBlock value].
						index <= self cursors size
							ifTrue: 
								[(self cursors at: index) show.
								index := index + 1.
								index > cursors size ifTrue: [index := 1]].
						(Delay forMilliseconds: self tick) wait]] 
				ifError: [:err :rcvr | cursor show]] newProcess.
	process priority: Processor userInterruptPriority.
	process resume.
	[result := aBlock value.
	cursor show.
	process terminate]
		ifError: 
			[:err :rcvr | 
			cursor show.
			process terminate].
	^result! !

!OomCursorAnimator methodsFor: 'animation' stamp: 'nishis 5/17/98 16:56'!
showWhileWithNoAmination: aBlock 
	| cursor result |
	cursor := Cursor currentCursor.
	self cursors first show.
	result := aBlock value.
	cursor show.
	^result! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomCursorAnimator class
	instanceVariableNames: ''!

!OomCursorAnimator class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomCursorAnimator class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomCursorAnimator class methodsFor: 'copyright'!
version
	^'010'! !


!OomCursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
flushCursors
	"OomCursorAnimator flushCursors."

	ClockCursors := nil.
	HandCursors := nil! !

!OomCursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
initialize
	"OomCursorAnimator initialize."

	self flushCursors! !

!OomCursorAnimator class methodsFor: 'class initialization' stamp: 'nishis 12/12/1998 22:33'!
install
	"OomCursorAnimator install."

	self clockCursors.
	self handCursors! !


!OomCursorAnimator class methodsFor: 'instance creation' stamp: 'nishis 5/17/98 16:10'!
clockCursors
	| cursorCollection |
	cursorCollection := OrderedCollection new.
	cursorCollection add: self clockCursor0.
	cursorCollection add: self clockCursor1.
	cursorCollection add: self clockCursor2.
	cursorCollection add: self clockCursor3.
	cursorCollection add: self clockCursor4.
	cursorCollection add: self clockCursor5.
	cursorCollection add: self clockCursor6.
	cursorCollection add: self clockCursor7.
	^super new cursors: cursorCollection! !

!OomCursorAnimator class methodsFor: 'instance creation' stamp: 'nishis 5/17/98 16:10'!
handCursors
	| cursorCollection |
	cursorCollection := OrderedCollection new.
	cursorCollection add: self handCursor0.
	cursorCollection add: self handCursor1.
	cursorCollection add: self handCursor2.
	cursorCollection add: self handCursor3.
	cursorCollection add: self handCursor4.
	cursorCollection add: self handCursor5.
	cursorCollection add: self handCursor4.
	cursorCollection add: self handCursor3.
	cursorCollection add: self handCursor2.
	cursorCollection add: self handCursor1.
	^super new cursors: cursorCollection! !

!OomCursorAnimator class methodsFor: 'instance creation'!
new
	^super new cursors: OrderedCollection new! !


!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:14'!
clockCursor0
	"OomCursorAnimator clockCursor0."
	"
	OomCursorAnimator clockCursor0 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000010001000000
2r1000010001000000
2r1000010001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:14'!
clockCursor1
	"OomCursorAnimator clockCursor1."
	"
	OomCursorAnimator clockCursor1 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000101000000
2r1000001001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:15'!
clockCursor2
	"OomCursorAnimator clockCursor2."
	"
	OomCursorAnimator clockCursor2 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001111101100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:15'!
clockCursor3
	"OomCursorAnimator clockCursor3."
	"
	OomCursorAnimator clockCursor3 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000001001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor4
	"OomCursorAnimator clockCursor4."
	"
	OomCursorAnimator clockCursor4 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000010001000000
2r1000010001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor5
	"OomCursorAnimator clockCursor5."
	"
	OomCursorAnimator clockCursor5 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1001110001100000
2r1000100001000000
2r1001000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:16'!
clockCursor6
	"OomCursorAnimator clockCursor6."
	"
	OomCursorAnimator clockCursor6 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1000000001000000
2r1000000001100000
2r1011110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
clockCursor7
	"OomCursorAnimator clockCursor7."
	"
	OomCursorAnimator clockCursor7 show.
	(Delay forSeconds: 2) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0100000010000000
2r1000000001000000
2r1001000001000000
2r1000100001100000
2r1001110001100000
2r1000000001000000
2r1000000001000000
2r0100000010000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			mask: #(
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0111111110000000
2r1111111111000000
2r1111111111000000
2r1111111111100000
2r1111111111100000
2r1111111111000000
2r1111111111000000
2r0111111110000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
2r0011111100000000
)
			offset: 5 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
handCursor0
	"OomCursorAnimator handCursor0."
	"
	OomCursorAnimator handCursor0 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0001101001110000
2r0010011001001000
2r0010011001001010
2r0001001001001101
2r0001001001001001
2r0110100000001001
2r1001100000000001
2r1000100000000010
2r0100000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0001101111110000
2r0011111111111000
2r0011111111111010
2r0001111111111111
2r0001111111111111
2r0110111111111111
2r1111111111111111
2r1111111111111110
2r0111111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:17'!
handCursor1
	"OomCursorAnimator handCursor1."
	"
	OomCursorAnimator handCursor1 show. 
	(Delay forSeconds: 5) wait. 
	Cursor normal show. 
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0001101001110000
2r0010011001001000
2r0010011001001010
2r0001001001001101
2r0001001001001001
2r0000100000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0001101111110000
2r0011111111111000
2r0011111111111010
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor2
	"OomCursorAnimator handCursor2."
	"
	OomCursorAnimator handCursor2 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000110000000
2r0000001001110000
2r0000001001001000
2r0000001001001010
2r0000111001001101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000110000000
2r0000001111110000
2r0000001111111000
2r0000001111111010
2r0000111111111111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor3
	"OomCursorAnimator handCursor3."
	"
	OomCursorAnimator handCursor3 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000110000
2r0000000001001000
2r0000000001001010
2r0000110111001101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000110000
2r0000000001111000
2r0000000001111010
2r0000110111111111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor4
	"OomCursorAnimator handCursor4."
	"
	OomCursorAnimator handCursor4 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000010
2r0000110110110101
2r0001001001001001
2r0001000000001001
2r0000100000000001
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000010
2r0000110110110111
2r0001111111111111
2r0001111111111111
2r0000111111111111
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !

!OomCursorAnimator class methodsFor: 'accessing' stamp: 'nishis 12/12/1998 22:18'!
handCursor5
	"OomCursorAnimator handCursor5."
	"
	OomCursorAnimator handCursor5 show.
	(Delay forSeconds: 5) wait.
	Cursor normal show.
	"

	^self
			extent: 16@16 
			fromArray: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000110110110000
2r0001001001001100
2r0001000000001010
2r0000100000000010
2r0001100000000010
2r0010000000000010
2r0010000000000010
2r0010000000000100
2r0001000000000100
2r0000100000001000
2r0000010000001000
2r0000010000001000
)
			mask: #(
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000000000000000
2r0000110110110000
2r0001111111111100
2r0001111111111110
2r0000111111111110
2r0001111111111110
2r0011111111111110
2r0011111111111110
2r0011111111111100
2r0001111111111100
2r0000111111111000
2r0000011111111000
2r0000011111111000
)
			offset: 7 @ 7! !


!OomCursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example1
	"OomCursorAnimator example1."

	| cursorAnimator cursorCollection |
	cursorAnimator := OomCursorAnimator new.
	cursorCollection := OrderedCollection new.
	(Parser new scanTokens: '
	#blank #bottomLeft #bottomRight #corner #crossHair
	#down #execute #marker #menu #move #normal
	#origin #read #rightArrow #square #topLeft #topRight
	#up #wait #write
	')
		do: [:each | cursorCollection add: (Cursor perform: each)].
	cursorAnimator cursors: cursorCollection.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!OomCursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example2
	"OomCursorAnimator example2."

	| cursorAnimator |
	cursorAnimator := OomCursorAnimator clockCursors.
	cursorAnimator tick: 125.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!OomCursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example3
	"OomCursorAnimator example3."

	| cursorAnimator |
	cursorAnimator := OomCursorAnimator handCursors.
	cursorAnimator tick: 300.
	cursorAnimator showWhile: [10000000 timesRepeat: []].
	^cursorAnimator! !

!OomCursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example4
	"OomCursorAnimator example4."

	| cursorAnimator |
	cursorAnimator := OomCursorAnimator clockCursors.
	cursorAnimator showWhileWithNoAmination: [10000000 timesRepeat: []].
	^cursorAnimator! !

!OomCursorAnimator class methodsFor: 'examples' stamp: 'nishis 7/25/1998 16:26'!
example5
	"OomCursorAnimator example5."

	| cursorAnimator |
	cursorAnimator := OomCursorAnimator handCursors.
	cursorAnimator showWhileWithNoAmination: [10000000 timesRepeat: []].
	^cursorAnimator! !


!OomCursorAnimator class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:25'!
extent: extentPoint fromArray: anArray mask: maskArray offset: offsetPoint
	| cursorMaker |
	cursorMaker := Smalltalk at: #CursorWithMask ifAbsent: [nil].
	cursorMaker isNil 
		ifTrue: 
			[^self extent: extentPoint fromArray: anArray offset: offsetPoint].
	^(cursorMaker 
			extent: extentPoint 
			fromArray: anArray
			offset: offsetPoint * -1)
		setMaskForm: 
			(Form 
				extent: extentPoint
				fromArray: (maskArray collect: [:bits | bits bitShift: 16]) 
				offset: 0 @ 0)! !

!OomCursorAnimator class methodsFor: 'private' stamp: 'nishis 12/12/1998 22:12'!
extent: extentPoint fromArray: anArray offset: offsetPoint 
	^Cursor extent: extentPoint fromArray: anArray offset: offsetPoint * -1! !


OomCursorAnimator initialize!
