'Oom010 (1/23/1999 6:20:40 pm)'.!


OomMetricBasic subclass: #OomMetricNOM
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-Basic'!
!OomMetricNOM commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricNOM methodsFor: 'computing'!
compute
	"(OomMetricNOM classes: Magnitude withAllSubclasses) compute."

	^self computeNOMs! !

!OomMetricNOM methodsFor: 'computing'!
computeNOM: aClass 
	"OomMetricNOM new computeNOM: Point."

	^aClass selectors size + aClass class selectors size! !

!OomMetricNOM methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:17'!
computeNOMs
	"(OomMetricNOM classes: Magnitude withAllSubclasses) computeNOMs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeNOM: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricNOM class
	instanceVariableNames: ''!

!OomMetricNOM class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricNOM class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricNOM class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricNOM class methodsFor: 'description'!
description
	^'number of methods per class'! !

!OomMetricNOM class methodsFor: 'description'!
nickname
	^'NOM'! !


!OomMetricNOM class methodsFor: 'examples'!
example1
	"OomMetricNOM example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOM classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricNOM class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:33'!
example2
	"OomMetricNOM example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricNOM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:18'!
example3
	"OomMetricNOM example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricNOM class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:18'!
example4
	"OomMetricNOM example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricNOM classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 200
				rank: 20.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
