'Oom010 (1/23/1999 6:20:43 pm)'.!


OomDisplayView subclass: #OomTableView
	instanceVariableNames: 'cells '
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Interface-Table'!
!OomTableView commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomTableView methodsFor: 'initialize-release' stamp: 'nishis 7/19/1998 13:33'!
scrollOffsetHolder: aValueHolder 
"	scrollOffset := aValueHolder.
	scrollOffset grid: [self scrollGrid].
	scrollOffset extraSpace: [self extraSpace]"! !


!OomTableView methodsFor: 'accessing' stamp: 'nishis 7/19/1998 13:38'!
cells
	| table |
	cells isNil
		ifTrue: 
			[table := self model table.
			cells := OomMatrix new: table rowSize by: table columnSize.
			self computeCells].
	^cells! !

!OomTableView methodsFor: 'accessing' stamp: 'nishis 7/19/1998 13:33'!
extraSpace
	^0 @ 0 corner: 0 @ 0! !

!OomTableView methodsFor: 'accessing' stamp: 'nishis 7/19/1998 13:33'!
margin
	^4 @ 1! !

!OomTableView methodsFor: 'accessing' stamp: 'nishis 7/19/1998 13:34'!
offset
	^2 @ 2! !

!OomTableView methodsFor: 'accessing' stamp: 'nishis 7/19/1998 13:34'!
scrollGrid
	^8 @ 8! !


!OomTableView methodsFor: 'display box accessing' stamp: 'nishis 7/19/1998 13:34'!
preferredBounds
	| box |
	box := (self cells atPoint: self cells rowSize @ self cells columnSize) first.
	box := (0 @ 0 corner: box corner)
				translateBy: self offset.
	box := box expandBy: self offset.
	^box! !


!OomTableView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:21'!
displayOn: graphicsContext 
	| box text area alignment scroll |
	scroll := self scrollAmount.
	self cells
		do: 
			[:cell | 
			box := cell first translateBy: self offset.
			area := box expandBy: (0 @ 0 corner: 1 @ 1).
			alignment := cell at: 2.
			text := cell last.
			self displayRectangularBorderOn: graphicsContext border: box.
			area := text boundingBox.
			area := area align: area center with: box center.
			alignment = #left ifTrue: [area := area align: area origin with: box origin + self margin].
			alignment = #right ifTrue: [area := area align: area corner with: box corner - self margin].
			text displayOn: graphicsContext at: area origin - scroll].
	self model visual: graphicsContext! !

!OomTableView methodsFor: 'displaying' stamp: 'nishis 11/14/1998 12:20'!
displayView
	| graphicsContext |
	(self isValidVisual) 
		ifFalse: 
			[self resetView.
			graphicsContext := Form extent: self preferredBounds extent.
			graphicsContext fillWithColor: self backgroundColor.
			self displayOn: graphicsContext]
		ifTrue: 
			[^super displayView]! !


!OomTableView methodsFor: 'controller accessing' stamp: 'nishis 7/19/1998 16:51'!
defaultControllerClass
	^OomTableController! !


!OomTableView methodsFor: 'updating' stamp: 'nishis 7/19/1998 16:52'!
update: aspectSymbol 
	aspectSymbol = #table ifTrue: [cells := nil].
	self display! !


!OomTableView methodsFor: 'private' stamp: 'nishis 7/19/1998 15:01'!
boundingRectangle
	^0 @ 0 extent: self preferredBounds extent! !

!OomTableView methodsFor: 'private' stamp: 'nishis 11/9/1998 05:27'!
computeCells
	| table width text x y box alignment w h |
	Cursor wait
		showWhile: 
			[table := self model table.
			cells := OomMatrix new: table rowSize by: table columnSize.
			x := 0.
			1 to: table columnSize
				do: 
					[:j | 
					y := 0.
					width := 0.
					table columnIndex: j
						doI: 
							[:each :i | 
							each isNil
								ifTrue: 
									[text := Paragraph withText: String new asText style: self textStyle.
									alignment := #center]
								ifFalse: [(each respondsTo: #asText)
										ifTrue: 
											[text := Paragraph withText: each asText style: self textStyle.
											alignment := #left]
										ifFalse: 
											[(each isKindOf: Number)
												ifTrue: [(each isKindOf: Integer)
														ifTrue: [text := Paragraph withText: each printString asText style: self textStyle]
														ifFalse: [text := Paragraph withText: (OomUtilities asFloat: each decimalCount: 2) asText style: self textStyle]]
														"ifFalse: [text := Paragraph withText: (each roundTo: 0.01) printString asText style: self textStyle]]"
												ifFalse: [text := Paragraph withText: each printString asText style: self textStyle].
											alignment := #right]].
							w := text boundingBox width + (self margin x * 2).
							h := text boundingBox height + (self margin y * 2).
							box := x @ y extent: w @ h.
							cells atPoint: i @ j put: (Array
									with: box
									with: alignment
									with: text).
							width := width max: w.
							y := y + h].
					cells columnIndex: j
						doI: 
							[:array :i | 
							box := array first.
							box := box origin corner: box origin x + width @ box corner y.
							text := array last.
							array at: 1 put: box].
					x := x + width]].
	^cells! !

!OomTableView methodsFor: 'private' stamp: 'nishis 8/1/1998 04:57'!
isValidVisual
	| visual |
	visual := self model visual.
	visual isNil ifTrue: [^false].
	(visual isKindOf: Form) not ifTrue: [^false].
	visual boundingBox ~= self boundingRectangle ifTrue: [^false].
	^true! !

!OomTableView methodsFor: 'private' stamp: 'nishis 11/7/1998 02:35'!
resetView
	self clearInside.
	self controller scrollViewTo: 0 @ 0! !

!OomTableView methodsFor: 'private' stamp: 'nishis 7/19/1998 13:39'!
textStyle
	^TextStyle default copy! !


!OomTableView methodsFor: 'private displaying' stamp: 'nishis 7/19/1998 16:06'!
displayBorderOn: graphicsContext box: aRectangle lineWidth: lineWidth color: aColor 
	| quadrangle |
	quadrangle := Quadrangle region: (aRectangle translateBy: self scrollAmount negated)
			borderWidth: lineWidth 
			borderColor: aColor 
			insideColor: nil.
	quadrangle displayOn: graphicsContext
! !

!OomTableView methodsFor: 'private displaying' stamp: 'nishis 7/19/1998 13:47'!
displayRectangularBorderOn: graphicsContext border: box
	self displayBorderOn: graphicsContext box: box lineWidth: 1 color: Color black! !

!OomTableView methodsFor: 'private displaying' stamp: 'nishis 7/19/1998 13:59'!
visibleAreas
	| visibleAreas aRectangle outsides myTopController |
	visibleAreas := Array with: self insetDisplayBox.
	self topView notNil 
		ifTrue: [myTopController := self topView controller]
		ifFalse: [myTopController := self controller].
	(myTopController isKindOf: ModalController) 
		ifTrue: [^visibleAreas].
	(myTopController view class canUnderstand: #uncacheBits) 
		ifTrue: [myTopController view uncacheBits].
	ScheduledControllers scheduledWindowControllers 
		do:
			[:aControllers | 
			aControllers == myTopController ifTrue: [^visibleAreas].
			aRectangle := aControllers view windowBox.
			outsides := OrderedCollection new.
			visibleAreas 
				do: 
					[:area | 
					outsides addAll: (area areasOutside: aRectangle)].
			visibleAreas := outsides].
	^visibleAreas! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomTableView class
	instanceVariableNames: ''!

!OomTableView class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomTableView class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomTableView class methodsFor: 'copyright'!
version
	^'010'! !
