'Oom010 (1/23/1999 6:20:43 pm)'.!


OomMetricCK subclass: #OomMetricDIT
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'Oom-Metrics-C&K'!
!OomMetricDIT commentStamp: '<historical>' prior: 0!
Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi!


!OomMetricDIT methodsFor: 'computing'!
compute
	"(OomMetricDIT classes: Magnitude withAllSubclasses) compute."

	^self computeDITs! !

!OomMetricDIT methodsFor: 'computing'!
computeDIT: aClass 
	"OomMetricDIT new computeDIT: Integer."

	^aClass allSuperclasses size! !

!OomMetricDIT methodsFor: 'computing' stamp: 'nishis 7/24/1998 02:20'!
computeDITs
	"(OomMetricDIT classes: Magnitude withAllSubclasses) computeDITs."

	| size targets dictionary count |
	size := (targets := self classes) size.
	dictionary := IdentityDictionary new: size.
	size <= 0 ifTrue: [^dictionary].
	count := 0.
	self interim value: count value: size.
	targets
		do: 
			[:each | 
			dictionary add: each name -> (self computeDIT: each).
			count := count + 1.
			self interim value: count value: size].
	^dictionary! !

"-- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- -- "!

OomMetricDIT class
	instanceVariableNames: ''!

!OomMetricDIT class methodsFor: 'copyright'!
copyright
	^'Oom010 (96/10/19) Copyright (C) 1996 AOKI Atsushi'! !

!OomMetricDIT class methodsFor: 'copyright'!
system
	^'Oom'! !

!OomMetricDIT class methodsFor: 'copyright'!
version
	^'010'! !


!OomMetricDIT class methodsFor: 'description'!
description
	^'depth of inheritance tree'! !

!OomMetricDIT class methodsFor: 'description'!
nickname
	^'DIT'! !


!OomMetricDIT class methodsFor: 'examples'!
example1
	"OomMetricDIT example1."

	| classes calculator result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricDIT classes: classes.
	result := calculator compute.
	calculator report: result.
	^result! !

!OomMetricDIT class methodsFor: 'examples' stamp: 'nishis 7/9/1998 00:34'!
example2
	"OomMetricDIT example2."

	| classes calculator progress result |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricDIT classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	calculator report2: result.
	^result! !

!OomMetricDIT class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:20'!
example3
	"OomMetricDIT example3."

	| classes calculator progress result matrix table |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricDIT classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	matrix := calculator convertToMatrix: result.
	table := OomTableMetrics table: matrix.
	table open.
	^result! !

!OomMetricDIT class methodsFor: 'examples' stamp: 'nishis 7/24/1998 02:20'!
example4
	"OomMetricDIT example4."

	| classes calculator progress result histogram |
	classes := Magnitude withAllSubclasses.
	calculator := OomMetricDIT classes: classes.
	progress := OomProgress new.
	progress message: 'computing...'.
	calculator interim: [:index :size | progress value: index / size].
	progress do: [result := calculator compute].
	histogram := OomHistogramModel
				sample: result
				min: 0
				max: 10
				rank: 10.
	histogram horizontal: calculator nicknameAndDescription.
	histogram vertical: 'number of classes'.
	histogram open.
	^result! !
